program main
!Rearrange atoms from Model.MD into order acceptable for configure/field file to simulate Si3N4 coating
character*7 :: ftitle1,ftitle2
character*4 :: m, AtomName,old
integer :: a, b, c, Group, GroupS, GroupN, GroupZ, GroupO, type, k, L,i, L1, L2,j
integer :: levfg,imcon, Nfix, coun, ncut,d,e,f,Print1,delete
integer, dimension(60000):: n1
real(8), dimension(3,60000)::r
real(8) :: x, y, z, fx, fy, fz, vx, vy, vz, Zmin, Ang
real(8) :: u1,u2,u3,v1,v2,v3,w1,w2,w3,xr,yr,zr,dd
real(8), allocatable :: xc(:),yc(:),zc(:),rcut(:)
real(8), dimension(20):: PoreD
Real(4), dimension(3,3) :: H0
Real(4) AtomVal

!Input the range of the porous electrode
xr=109.3718027344; yr=33.6744003296; zr=114.9860000610
L1=45024    ! The total number of atoms in phase 1, say SnO2
L=45792     ! The total number of atoms in REVCON
Zmin= -30.3536 ! need to chage with model

!Initialization of the pore sizes
PoreD(1)=0.65; PoreD(2)=0.7; PoreD(3)=0.75; PoreD(4)=0.85; 
PoreD(5)=1.05; PoreD(6)=1.25; PoreD(7)=1.5; PoreD(8)=1.65; 
PoreD(9)=1.85; PoreD(10)=2.25; PoreD(11)=2.6; PoreD(12)=3.1;
PoreD(13)=4.0; PoreD(14)=5.1   !17.38807

ncut=158*50    !3    !must be integer times 158
allocate(xc(1:ncut))
allocate(yc(1:ncut))
allocate(zc(1:ncut))
allocate(rcut(1:ncut))
!Adjust the pore sizes
do i=0, ncut/158-1
  do k=1, 16
  rcut(i*158+k)=PoreD(1)
  enddo
!rcut(1)=PoreD(1); rcut(2)=PoreD(1); rcut(3)=PoreD(1); rcut(4)=PoreD(1);
!rcut(5)=PoreD(1); rcut(6)=PoreD(1); rcut(7)=PoreD(1); rcut(8)=PoreD(1);
!rcut(9)=PoreD(1); rcut(10)=PoreD(1); rcut(11)=PoreD(1); rcut(12)=PoreD(1);
!rcut(13)=PoreD(1); rcut(14)=PoreD(1); rcut(15)=PoreD(1); rcut(16)=PoreD(1);
  
   do k=17,40
  rcut(i*158+k)=PoreD(2)
  enddo
   
!rcut(17)=PoreD(2); rcut(18)=PoreD(2); rcut(19)=PoreD(2); rcut(20)=PoreD(2);
!rcut(21)=PoreD(2); rcut(22)=PoreD(2); rcut(23)=PoreD(2); rcut(24)=PoreD(2);
!rcut(25)=PoreD(2); rcut(26)=PoreD(2); rcut(27)=PoreD(2); rcut(28)=PoreD(2);
!rcut(29)=PoreD(2); rcut(30)=PoreD(2); rcut(31)=PoreD(2); rcut(32)=PoreD(2);
!rcut(33)=PoreD(2); rcut(34)=PoreD(2); rcut(35)=PoreD(2); rcut(36)=PoreD(2);
!rcut(37)=PoreD(2); rcut(38)=PoreD(2); rcut(39)=PoreD(2); rcut(40)=PoreD(2);

   do k=41,66
  rcut(i*158+k)=PoreD(3)
  enddo
!rcut(41)=PoreD(3); rcut(42)=PoreD(3); rcut(43)=PoreD(3); rcut(44)=PoreD(3);
!rcut(45)=PoreD(3); rcut(46)=PoreD(3); rcut(47)=PoreD(3); rcut(48)=PoreD(3);
!rcut(49)=PoreD(3); rcut(50)=PoreD(3); rcut(51)=PoreD(3); rcut(52)=PoreD(3);
!rcut(53)=PoreD(3); rcut(54)=PoreD(3); rcut(55)=PoreD(3); rcut(56)=PoreD(3);
!rcut(57)=PoreD(3); rcut(58)=PoreD(3); rcut(59)=PoreD(3); rcut(60)=PoreD(3);
!rcut(61)=PoreD(3); rcut(62)=PoreD(3); rcut(63)=PoreD(3); rcut(64)=PoreD(3);
!rcut(65)=PoreD(3); rcut(66)=PoreD(3);

   do k=67,83
  rcut(i*158+k)=PoreD(4)
  enddo
!rcut(67)=PoreD(4); rcut(68)=PoreD(4); rcut(69)=PoreD(4); rcut(70)=PoreD(4);
!rcut(71)=PoreD(4); rcut(72)=PoreD(4); rcut(73)=PoreD(4); rcut(74)=PoreD(4);
!rcut(75)=PoreD(4); rcut(76)=PoreD(4); rcut(77)=PoreD(4); rcut(78)=PoreD(4);
!rcut(79)=PoreD(4); rcut(80)=PoreD(4); rcut(81)=PoreD(4); rcut(82)=PoreD(4);
!rcut(83)=PoreD(4); 

   do k=84,96
  rcut(i*158+k)=PoreD(5)
  enddo
!rcut(84)=PoreD(5); rcut(85)=PoreD(5); rcut(86)=PoreD(5);rcut(87)=PoreD(5);
!rcut(88)=PoreD(5); rcut(89)=PoreD(5); rcut(90)=PoreD(5);rcut(91)=PoreD(5);
!rcut(92)=PoreD(5); rcut(93)=PoreD(5); rcut(94)=PoreD(5);rcut(95)=PoreD(5); 
!rcut(96)=PoreD(5); 

   do k=97,107
  rcut(i*158+k)=PoreD(6)
  enddo
!rcut(97)=PoreD(6); rcut(98)=PoreD(6);rcut(99)=PoreD(6); rcut(100)=PoreD(6)
!rcut(101)=PoreD(6); rcut(102)=PoreD(6); rcut(103)=PoreD(6); rcut(104)=PoreD(6);
!rcut(105)=PoreD(6); rcut(106)=PoreD(6); rcut(107)=PoreD(6);

   do k=108,117
  rcut(i*158+k)=PoreD(7)
  enddo
!rcut(108)=PoreD(7);rcut(109)=PoreD(7); rcut(110)=PoreD(7); rcut(111)=PoreD(7);
!rcut(112)=PoreD(7);rcut(113)=PoreD(7); rcut(114)=PoreD(7); rcut(115)=PoreD(7);
!rcut(116)=PoreD(7);rcut(117)=PoreD(7);

   do k=118,126
  rcut(i*158+k)=PoreD(8)
  enddo
!rcut(118)=PoreD(8);rcut(119)=PoreD(8); rcut(120)=PoreD(8); rcut(121)=PoreD(8);
!rcut(122)=PoreD(8);rcut(123)=PoreD(8); rcut(124)=PoreD(8); rcut(125)=PoreD(8);
!rcut(126)=PoreD(8);

   do k=127,135
  rcut(i*158+k)=PoreD(9)
  enddo
!rcut(127)=PoreD(9);rcut(128)=PoreD(9); rcut(129)=PoreD(9); rcut(130)=PoreD(9);
!rcut(131)=PoreD(9);rcut(132)=PoreD(9); rcut(133)=PoreD(9); rcut(134)=PoreD(9);
!rcut(135)=PoreD(9);

   do k=136,143
  rcut(i*158+k)=PoreD(10)
  enddo
!rcut(136)=PoreD(10);rcut(137)=PoreD(10); rcut(138)=PoreD(10); rcut(139)=PoreD(10);
!rcut(140)=PoreD(10);rcut(141)=PoreD(10); rcut(142)=PoreD(10); rcut(143)=PoreD(10);

   do k=144,149
  rcut(i*158+k)=PoreD(11)
  enddo
!rcut(144)=PoreD(11); rcut(145)=PoreD(11); rcut(146)=PoreD(11); rcut(147)=PoreD(11);
!rcut(148)=PoreD(11); rcut(149)=PoreD(11); 

   do k=150,153
  rcut(i*158+k)=PoreD(12)
  enddo
!rcut(150)=PoreD(12); rcut(151)=PoreD(12);rcut(152)=PoreD(12); rcut(153)=PoreD(12); 

   do k=154,156
  rcut(i*158+k)=PoreD(13)
  enddo
!rcut(154)=PoreD(13); rcut(155)=PoreD(13); rcut(156)=PoreD(13); 

   do k=157,158
  rcut(i*158+k)=PoreD(14)
  enddo
!rcut(157)=PoreD(14); rcut(158)=PoreD(14); 
enddo

call init_random_seed()

do i=1,ncut
call random_number(xc(i))
!write(*,*) "the random number for xc is", i, xc(i)
xc(i)=(xc(i)-0.5)*xr
call random_number(yc(i))
!write(*,*) "the random number for yc is", i, yc(i)
yc(i)=(yc(i)-0.5)*yr
call random_number(zc(i))
!write(*,*) "the random number for zc is", i, zc(i)
zc(i)=(zc(i)-0.5)*zr+6.8 !need to adjust if it is a rod
!               write(9,'(i10,4f20.9)')i,xc(i),yc(i),zc(i),rcut(i)
!call random_number(rcut(i))
!rcut(i)=rcut(i)*rcutr
enddo

open(unit=9,file='XYZPores.cfg', status='UNKNOWN')
WRITE(9,'(a21,I8)') 'Number of particles =',L1
!write(9,*) "i, xc, yc, zc, rcut for all the pores informatiion"
Ang=1.0  !Angstrom
WRITE(9,'(a4,f5.2,a30)') 'A = ',Ang,' Angstrom (basic length-scale)'

  H0(1,1)=xr
  H0(1,2)=0.0
  H0(1,3)=0.0
  H0(2,1)=0.0
  H0(2,2)=yr
  H0(2,3)=0.0
  H0(3,1)=0.0
  H0(3,2)=0.0
  H0(3,3)=zr
WRITE(9,'(a9,f24.15,a2)') 'H0(1,1) =',H0(1,1),' A'
WRITE(9,'(a9,f15.11,a2)') 'H0(1,2) =',H0(1,2),' A'
WRITE(9,'(a9,f15.11,a2)') 'H0(1,3) =',H0(1,3),' A'
WRITE(9,'(a9,f15.11,a2)') 'H0(2,1) =',H0(2,1),' A'
WRITE(9,'(a9,f15.11,a2)') 'H0(2,2) =',H0(2,2),' A'
WRITE(9,'(a9,f15.11,a2)') 'H0(2,3) =',H0(2,3),' A'
WRITE(9,'(a9,f15.11,a2)') 'H0(3,1) =',H0(3,1),' A'
WRITE(9,'(a9,f15.11,a2)') 'H0(3,2) =',H0(3,2),' A'
WRITE(9,'(a9,f15.11,a2)') 'H0(3,3) =',H0(3,3),' A'
WRITE(9,'(a13)') '.NO_VELOCITY.'
WRITE(9,'(a15)') 'entry_count = 3'

Group=1 
GroupS=1     !0
GroupN=1     !0
GroupZ=1
GroupO=1

open(10,file='REVCON', status='old')
open(unit=11,file='CONFIG', status='UNKNOWN')
open(unit=12,file='temp1', status='UNKNOWN')
open(unit=13,file='temp2', status='UNKNOWN')

read(10,*) ftitle1   !,ftitle2
write(11,*)ftitle1    !,ftitle2
read(10,*) levfg, imcon
write(11,'(i10,i10)')levfg,imcon
read(10,*)u1,u2,u3
write(11,'(3f20.10)')u1,u2,u3
read(10,*)v1,v2,v3
write(11,'(3f20.10)')v1,v2,v3
read(10,*)w1,w2,w3
write(11,'(3f20.10)')w1,w2,w3
delete=0
c=0
do 110 i=1,L1    !read and group the Al2O3 atoms
		read(10,*) m,type
		read(10,*)x,y,z
                read(10,*)vx,vy,vz
                read(10,*)fx,fy,fz
        do j=1, ncut
              dd=sqrt((x-xc(j))**2+(y-yc(j))**2+(z-zc(j))**2)
          if(dd.le.rcut(j)) then
                if(m.eq.'O') then
                AtomVal=15.99
                else if(m.eq.'P') then
                AtomVal=30.97
                else if(m.eq.'Li') then
                AtomVal=6.94
                else if(m.eq.'Sn') then
                AtomVal=118.69
                else if(m.eq.'Mn') then
                AtomVal=59.94
                else
                write(*,*) "modify code to include more elements (only O,Li,P,Sn,Mn available)"
               endif
          AtomName=m
          delete=delete+1
                if ((delete.eq.1) .or.(AtomName.ne.old)) then
                 write(9,*)AtomVal
                 write(9,*) m
                endif
               old=m
             write(9,'(3f20.9)')x/xr+0.5,y/yr+0.5,z/zr+0.5
          go to 110
          endif
        enddo
               write(12,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
               c=c+1
110 continue

close(9)
write(*,*) "Number of particles in XYZPores.cfg should be changed to", delete

do 9 i=L1+1,L    !read and group the Al2O3 atoms
		read(10,*) m,type
		read(10,*)x,y,z
                read(10,*)vx,vy,vz
                read(10,*)fx,fy,fz
                write(13,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
9 enddo

call flush(12)
call flush(13)

call system("sort -n -k 5 temp1 > phase1")
call system("sort -n -k 5 temp2 > phase2")
open(unit=14,file='phase1',status='UNKNOWN')
open(unit=15,file='phase2',status='UNKNOWN')

close (12, status='delete'); close (13, status='delete')


open(unit=16,file='tempSn', status='UNKNOWN')
open(unit=17,file='tempO1', status='UNKNOWN')
open(unit=18,file='tempLi1', status='UNKNOWN')
open(unit=19,file='tempP', status='UNKNOWN')
open(unit=20,file='tempO2', status='UNKNOWN')
open(unit=21,file='tempMn', status='UNKNOWN')
open(unit=22,file='tempLi2', status='UNKNOWN')

a=0
b=0
d=0
e=0
do i=1,c
        read(14,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
        
        if (m.eq.'Li')then
         write(22,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
         a=a+1
        else if (m.eq.'Mn') then
         write(21,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
         d=d+1
        else
         write(17,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
         e=e+1
        endif
enddo
!do i=1,c
 !              read(14,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
  !  if (m.eq.'Sn') then
   !            write(16,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
    !          a=a+1
    !else
     !          write(17,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
      !         d=d+1
   ! endif
!enddo

do  i=L1+1,L    
               read(15,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
    if (m.eq.'Li') then
               write(18,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
               b=b+1
    else if (m.eq.'P') then
               write(19,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
    else
               write(20,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
   endif
enddo

close (14, status='delete'); close (15, status='delete')

rewind (16); rewind (17);  rewind (18); rewind (19); rewind (20); rewind (21);
rewind (22)

if(a .le. d .and. a .le. 0.5*e) then
Print1=INT(a/2)
!Print1=8*Print1
else if (d .le. a .and. d .le. 0.5*e) then
Print1=INT(d/2)
!Print1=Print1*8
else
Print1=INT(e/4)
!Print1=Print1*8
endif

write(*,*) "the number, fraction of LiMnO2 atoms are deleted", L1-Print1*8,((L1-(Print1*8))/float(L1))

do 11 i=1, Print1  
	do j=1,2
                read(22,*) m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, (i-1)*8+j
                write(11,'(3f20.9)')x,y,z
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
        enddo
        
        do j=3,4
                read(21,*) m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, (i-1)*8+j
                write(11,'(3f20.9)')x,y,z
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
        enddo

	do j=5,8
                read(17,*) m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, (i-1)*8+j
                write(11,'(3f20.9)')x,y,z
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
        enddo

11 enddo

Nfix=0  ! Initialization
coun=0

do 12 i=1,(L-L1)/16   
        do j=1,6
               read(18,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, Print1*8+(i-1)*16+j
                write(11,'(3f20.9)')x,y,z
                 if (z.le.Zmin) then
                  coun=coun+1
                 endif
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
       enddo
        do j=7,8
                read(19,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, Print1*8+(i-1)*16+j
                write(11,'(3f20.9)')x,y,z
                 if (z.le.Zmin) then
                  coun=coun+1
                 endif
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
       enddo
        do j=9,16
                read(20,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, Print1*8+(i-1)*16+j
                write(11,'(3f20.9)')x,y,z
                 if (z.le.Zmin) then
                  coun=coun+1
                 endif
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
       enddo

       if (coun.ge.(Nfix+1)) then
         Nfix=Nfix+1
         coun=Nfix
       endif
12 enddo

write(*,*) "the number of groups in Li3PO4 need to be fixed is", Nfix

close(unit=16,status='delete'); close(unit=17, status='delete')
close(unit=18, status='delete'); close(unit=19, status='delete')
close(unit=20, status='delete'); close(unit=21, status='delete')
close(unit=22, status='delete')
close(unit=10)
close(unit=11)
end program main

subroutine init_random_seed()
integer:: i, n, clock
integer, dimension(:), allocatable:: seed

call random_seed(size = n)
allocate(seed(n))

call system_clock(count=clock)
seed = clock + 37 * (/(i-1, i = 1, n)/)
call random_seed(put = seed)
deallocate(seed)
end subroutine
