program main

integer :: ic,nc,mxp,na,i,j,k
real(8), allocatable :: MSD(:,:), D(:),dummy(:), Slope(:,:)
real(8) dt
character (len = 20) :: file_inp= "statis.inp" !input file
character (len = 20) :: file_STATIS ! input file containing HISTORY
character (len=4), allocatable :: element(:)


open(99,file=file_inp,status="old",action="read")
read(99,*) nc
read(99,*) file_STATIS
read(99,*) mxp   !how many parameters are written in STATIS file
read(99,*) dt
read(99,*) na    !number of atomic sites

allocate(element(1:na))

do i=1, na
read(99,*) element(i)
enddo

close(99)

allocate(MSD(1:40,1:na))
allocate(Slope(1:40,1:na))
allocate(D(1:na))
allocate(dummy(1:((INT(mxp/5)-5)*5)))
MSD=0.d0
D=0.d0
dummy=0.d0
Slope=0.d0

write(*,*) "the number of line of parameters in STATIS file is", INT(mxp/5)+1

open(10,file='STATIS', status='old', action='read')
read(10,*)
read(10,*)
do i=1, nc-40  ! nc must larger than 40
 do j=1, INT(mxp/5)+2 ! mxp must not be integer times five
read(10,*)
 enddo
enddo

open(11,file='MSD', action='write')

do i=1, 40
 do j=1, 6
 read(10,*)
 enddo
 do j=1, INT(mxp/5)-5
 read(10,*) dummy(5*j-4),dummy(5*j-3),dummy(5*j-2),dummy(5*j-1),dummy(5*j)
 enddo
 read(10,*)
 do k=1, na
 MSD(i,k)= dummy(2+k)
 enddo
write(11,*) MSD(i,:)
enddo

close(10)

!do i=2, 39
!do k=1, na
!Slope(i,k)= (MSD((i+1),k)-MSD((i-1),k))/dt/2
!D(k)=MSD(k)/20/dt/6
!write(11,*) "its diffusion coefficient is ", D(k)
!enddo
!write(11,*) Slope(i,:)
!enddo
close(11)

end program main



