program main
!Rearrange atoms from Model.MD into order acceptable for configure/field file to simulate Si3N4 coating

character*7 :: ftitle1,ftitle2
integer :: a, b, Group, GroupS, GroupN, GroupZ, GroupO, type, k, L,i, L1
integer :: levfg,imcon
integer, dimension(60000):: n1
real(8), dimension(3,60000)::r
real(8) :: x, y, z, vx, vy, vz, fx, fy, fz, Disp
real(8) :: u1,u2,u3,v1,v2,v3,w1,w2,w3
character(4) :: m

Disp1=6.86    !need to adjust
Disp2=-27.4936
L1=4944   ! for the total number of SiO2
L=4944+4672  ! For the total number of SiO2 and Li3PO4; here 4672 is for Li3PO4

open(10,file='CONFIG_SnO2', status='old')
open(unit=11,file='CONFIG', status='unknown')

read(10,*) ftitle1
write(11,*)ftitle1
read(10,*) levfg, imcon
write(11,'(i10,i10)')levfg,imcon
read(10,*)u1,u2,u3
write(11,'(3f20.10)')u1,u2,u3
read(10,*)v1,v2,v3
write(11,'(3f20.10)')v1,v2,v3
read(10,*)w1,w2,w3
write (*,*) "w3, Disp1", w3, Disp1
write(11,'(3f20.10)')w1,w2,w3+2*Disp1+40

do 11 i=1, L1    
		read(10,*) m,type
                write(11,'(a8,i10)')m,i
		read(10,*)x,y,z
                write(11,'(3f20.9)')x,y,z+Disp1
!		read(10,*)vx,vy,vz
!                write(11,'(3f20.9)')vx,vy,vz
!		read(10,*)fx,fy,fz
!                write(11,'(3f20.9)')fx,fy,fz
11 enddo
close(unit=10)

open(10,file='CONFIG_Li3PO4', status='old')
open(unit=11,file='CONFIG', status='unknown')

read(10,*) ftitle1
read(10,*) levfg, imcon
read(10,*)u1,u2,u3
read(10,*)v1,v2,v3
read(10,*)w1,w2,w3

do 22 i=L1+1, L
read(10,*) m,type
write(11,'(a8,i10)')m,i
read(10,*)x,y,z
write(11,'(3f20.9)')x,y,z+Disp2
!read(10,*)vx,vy,vz
!write(11,'(3f20.9)')vx,vy,vz
!read(10,*)fx,fy,fz
!write(11,'(3f20.9)')fx,fy,fz
22 enddo

close(unit=10)
close(unit=11)
end program main

