program main
!Rearrange atoms from Model.MD into order acceptable for configure/field file to simulate Si3N4 coating

character*7 :: ftitle1,ftitle2
integer :: a, b, c, d, GroupO, GroupS, GroupN, type, k, L,i, L1, Print1, Print2
integer :: levfg,imcon
integer, dimension(600000):: n1
real(8), dimension(3,600000)::r
real(8) :: x, y, z
real(8) :: u1,u2,u3,v1,v2,v3,w1,w2,w3
character :: m, Al, O,  Fe


L1=45036   !  The total atom number of first part!12288
L=45934    !  The total atom number of the model

open(10,file='Model.MD', status='old')
open(unit=11,file='CONFIG', status='UNKNOWN')

read(10,*) ftitle1,ftitle2
write(11,*)ftitle1,ftitle2
read(10,*) levfg, imcon
write(11,'(i10,i10)')levfg,imcon
read(10,*)u1,u2,u3
write(11,'(3f20.10)')u1,u2,u3
read(10,*)v1,v2,v3
write(11,'(3f20.10)')v1,v2,v3
read(10,*)w1,w2,w3
write(11,'(3f20.10)')w1,w2,w3

a=1
b=1
c=1
d=0
e=0
f=0
GroupS=1 !0
GroupN=1  !0
GroupO=1 !0

do 200 i=1 , L1
		read(10,*) m,type
                read(10,*) x,y,z
       if (type.eq.3) then 
			 if (a.eq.3) then
					a = 1
					GroupS = GroupS + 1
		         endif
               k=(groupS-1)*8+a      ! Fan
               r(1,k)=x          ! Fan
               r(2,k)=y          ! Fan
               r(3,k)=z          ! Fan
               n1(k)=type         ! Fan
			     	a = a + 1
              d=d+1
      else if (type.eq.25) then
			  if (b.eq.3) then
					b = 1
					GroupN = GroupN + 1
				     endif
               k=(groupN-1)*8+2+b
               r(1,k)=x
               r(2,k)=y
               r(3,k)=z
               n1(k)=type
				b = b+1
            e=e+1
      else if (type.eq.8) then
			  if (c.eq.5) then
					c = 1
					GroupO = GroupO + 1
				     endif
               k=(groupO-1)*8+4+c
               r(1,k)=x
               r(2,k)=y
               r(3,k)=z
               n1(k)=type
				c = c+1
            f=f+1
     endif
200	 enddo

		write(*,*) 'The number of Li atoms is', d
		write(*,*) 'The number of Mn atoms is', e
                write(*,*) 'The number of O atoms is', f

if(d .le. e .and. d .le. 0.5*f) then
    Print1=d/2
    Print1=Print1*8
    else if(e .le. d .and. e .le. 0.5*f) then
    Print1=e/2
    Print1=Print1*8
    else
    Print1=f/4
    Print1=Print1*8
endif
              write(*,*) 'total LiMnO2 is', Print1

 do 100 k=1, Print1
       if (n1(k).eq.3)then
            write(11,'(a8,i10)')'Li',k
            write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
       else if (n1(k).eq.25)then
            write(11,'(a8,i10)')'Mn',k
            write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
       else
            write (11,'(a8,i10)')'O',k
            write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
           endif
100    enddo
  !       do 200 k=1,L
   !       if (n1(k).eq.50)then
    !        write (11,'(a8,i10)')'Sn',k
     !       write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
      !    else
       !     
        !    write (11,'(a8,i10)')'O',k
         !   write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
          !endif
!200      enddo

!do 100 i=1,L1
!		read(10,*) m,type
!                write(*,*) m,type
!		read(10,*)x,y,z
!                write(*,*)x,y,z
!          if (type.eq.50) then
!				210 if (a.eq.3) then
!					a = 1
!					GroupS = GroupS + 1
!				    endif
!              k=(groups-1)*6+a      ! Fan
!               r(1,k)=x          ! Fan
!               r(2,k)=y          ! Fan
!               r(3,k)=z          ! Fan
!               n1(k)=type         ! Fan
!			     	a = a + 1
!              c=c+1
!	  else
!			         211 if (b.eq.5) then
!					b = 1
!					GroupN = GroupN + 1
!				     endif
 !              k=(groupN-1)*6+2+b
  !             r(1,k)=x
  !             r(2,k)=y
   !            r(3,k)=z
    !           n1(k)=type
!				b = b+1
 !           d=d+1
!	   endif
!100	 enddo

!		write(*,*) 'The number of Sn atoms is', c
!                write(*,*) 'The number of O atoms is', d
!   if(d .le. 2*c) then
!   Print1=d/4
!   Print1=6*Print1
!   else 
!   Print1=c/2
!   Print2=Print2*6
!   endif
 !             write(*,*) 'Total SnO2 is', Print1

 !       do 200 k=1, Print1
 !          if (n1(k).eq.50)then
 !           write (11,'(a8,i10)')'Sn',k
 !           write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
 !          else
 !         
 !           write (11,'(a8,i10)')'O',k
 !           write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
 !          endif
!200    enddo

a=1
b=1
c=1
d=0
e=0
f=0
GroupS=1 !0
GroupN=1  !0
GroupO=1 !0

do 300 i=L1+1,L
		read(10,*) m,type
                read(10,*) x,y,z
       if (type.eq.3) then 
			 if (a.eq.7) then
					a = 1
					GroupS = GroupS + 1
		         endif
               k=(groupS-1)*16+a      ! Fan
               r(1,k)=x          ! Fan
               r(2,k)=y          ! Fan
               r(3,k)=z          ! Fan
               n1(k)=type         ! Fan
			     	a = a + 1
              d=d+1
      else if (type.eq.15) then
			  if (b.eq.3) then
					b = 1
					GroupN = GroupN + 1
				     endif
               k=(groupN-1)*16+6+b
               r(1,k)=x
               r(2,k)=y
               r(3,k)=z
               n1(k)=type
				b = b+1
            e=e+1
      else if (type.eq.8) then
			  if (c.eq.9) then
					c = 1
					GroupO = GroupO + 1
				     endif
               k=(groupO-1)*16+8+c
               r(1,k)=x
               r(2,k)=y
               r(3,k)=z
               n1(k)=type
				c = c+1
            f=f+1
     endif
300	 enddo

		write(*,*) 'The number of Li atoms is', d
		write(*,*) 'The number of P atoms is', e
                write(*,*) 'The number of O atoms is', f

if(d .le. 3*e .and. d .le. 0.75*f) then
    Print2=d/6
    Print2=Print2*16
    else if(e .le. 1./3.*d .and. e .le. 0.25*f) then
    Print2=e/2
    Print2=Print2*16
    else
    Print2=f/8
    Print2=Print2*16
endif
              write(*,*) 'total Li3PO4 is', Print2

 do 400 k=1, Print2
       if (n1(k).eq.3)then
            write(11,'(a8,i10)')'Li',k+Print1
            write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
       else if (n1(k).eq.15)then
            write(11,'(a8,i10)')'P',k+Print1
            write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
       else
            write (11,'(a8,i10)')'O',k+Print1
            write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
           endif
400    enddo
  !       do 200 k=1,L
   !       if (n1(k).eq.50)then
    !        write (11,'(a8,i10)')'Sn',k
     !       write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
      !    else
       !     
        !    write (11,'(a8,i10)')'O',k
         !   write (11,'(3f20.9)')r(1,k),r(2,k),r(3,k)
          !endif
!200      enddo

close(unit=10)
close(unit=11)
end program main

