program main

character*80 :: Source_file
character*80 :: Object_file
integer :: ic,nc,mxp,na,i,j,k,lis
real(8), allocatable :: Vol(:), Temp(:),Conf_ene(:), Tot_vir(:),dummy(:)
!real(8) dt
!character (len = 20) :: file_inp= "statis.inp" !input file
!character (len = 20) :: file_STATIS ! input file containing HISTORY
!character (len=4), allocatable :: element(:)
character*4 frame, nstpval


if(iargc().ne.(3))then
write(*,*) "arguments are [frameNum] [pvalNum] [STATISFile]"
call exit
end if
call getarg(1, frame)
call getarg(2, nstpval)
call getarg(3, Source_file)
!call getarg(4, Object_file)

read(frame,'(i4)') nc
read(nstpval,'(i4)') mxp   !how many parameters are written in STATIS file
!read(99,*) na    !number of atomic sites

allocate(Vol(1:nc))
allocate(Temp(1:nc))
allocate(Conf_ene(1:nc))
allocate(Tot_vir(1:nc))
allocate(dummy(1:mxp))

!do i=1, na
!read(99,*) element(i)
!enddo


!allocate(MSD(1:40,1:na))
!allocate(Slope(1:40,1:na))
!allocate(D(1:na))
!allocate(dummy(1:((INT(mxp/5)-5)*5)))
!MSD=0.d0
!D=0.d0
!dummy=0.d0
!Slope=0.d0

write(*,*) "the number of line of parameters in STATIS file is", INT(mxp/5)+1

lis=len_trim(Source_file)
open(unit=10,file=Source_file(1:lis), status='old', action='read')
read(10,*)
read(10,*)
!do i=1, nc  ! nc must larger than 40
! do j=1, INT(mxp/5)+2 ! mxp must not be integer times five
!read(10,*)
! enddo
!enddo

open(11,file='Data_TEVS', action='write')

do i=1, nc
! do j=1
 read(10,*)
! enddo
 do j=1, INT(mxp/5)
 read(10,*) dummy(5*j-4),dummy(5*j-3),dummy(5*j-2),dummy(5*j-1),dummy(5*j)
 enddo
   Vol(i)=dummy(2)
   Temp(i)=dummy(3)
   Conf_ene(i)=dummy(12)
   Tot_vir(i)=dummy(19)
!write(*,*) Tot_vir(i)
read(10,*)
write(11,'(e15.6,4(A1,e15.6))')i*0.05,char(09),Vol(i),char(09),Temp(i),char(09),&
Conf_ene(i),char(09),Tot_vir(i)
enddo

close(10)

!do i=2, 39
!do k=1, na
!Slope(i,k)= (MSD((i+1),k)-MSD((i-1),k))/dt/2
!D(k)=MSD(k)/20/dt/6
!write(11,*) "its diffusion coefficient is ", D(k)
!enddo
!write(11,*) Slope(i,:)
!enddo
close(11)

end program main



