program main
!Rearrange atoms from Model.MD into order acceptable for configure/field file to simulate Si3N4 coating
character*7 :: ftitle1,ftitle2, m
integer :: a, b, c, Group, GroupS, GroupN, GroupZ, GroupO, type, k, L,i, L1, L2,j
integer :: levfg,imcon, Nfix, coun
integer, dimension(60000):: n1
real(8), dimension(3,60000)::r
real(8) :: x, y, z, fx, fy, fz, vx, vy, vz, Zmin
real(8) :: u1,u2,u3,v1,v2,v3,w1,w2,w3
character :: Al, O,Zn

Group=1 
GroupS=1     !0
GroupN=1     !0
GroupZ=1
GroupO=1
L1=4944    ! The total number of atoms in phase 1, say SnO2
L=9616     ! The total number of atoms in REVCON
Zmin= -30.3536 ! need to chage with model

open(10,file='REVCON', status='old')
open(unit=11,file='CONFIG', status='UNKNOWN')
open(unit=12,file='temp1', status='UNKNOWN')
open(unit=13,file='temp2', status='UNKNOWN')

read(10,*) ftitle1   !,ftitle2
write(11,*)ftitle1    !,ftitle2
read(10,*) levfg, imcon
write(11,'(i10,i10)')levfg,imcon
read(10,*)u1,u2,u3
write(11,'(3f20.10)')u1,u2,u3
read(10,*)v1,v2,v3
write(11,'(3f20.10)')v1,v2,v3
read(10,*)w1,w2,w3
write(11,'(3f20.10)')w1,w2,w3

do 110 i=1,L1    !read and group the Al2O3 atoms
		read(10,*) m,type
		read(10,*)x,y,z
                read(10,*)vx,vy,vz
                read(10,*)fx,fy,fz
               write(12,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
110 enddo

do 9 i=L1+1,L    !read and group the Al2O3 atoms
		read(10,*) m,type
		read(10,*)x,y,z
                read(10,*)vx,vy,vz
                read(10,*)fx,fy,fz
                write(13,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
9 enddo

call flush(12)
call flush(13)

call system("sort -n -k 5 temp1 > phase1")
call system("sort -n -k 5 temp2 > phase2")
open(unit=14,file='phase1',status='UNKNOWN')
open(unit=15,file='phase2',status='UNKNOWN')

close (12, status='delete'); close (13, status='delete')


open(unit=16,file='tempSn', status='UNKNOWN')
open(unit=17,file='tempO1', status='UNKNOWN')
open(unit=18,file='tempLi', status='UNKNOWN')
open(unit=19,file='tempP', status='UNKNOWN')
open(unit=20,file='tempO2', status='UNKNOWN')

a=0
b=0

do i=1,L1
               read(14,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
    if (m.eq.'Sn') then
               write(16,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
              a=a+1
    else
               write(17,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
    endif
enddo

do  i=L1+1,L    
               read(15,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
    if (m.eq.'Li') then
               write(18,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
               b=b+1
    else if (m.eq.'P') then
               write(19,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
    else
               write(20,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
   endif
enddo
write(*,*) "the number of Sn and Li atoms,  L1/6 re ", a, b, L1/6

close (14, status='delete'); close (15, status='delete')

rewind (16); rewind (17);  rewind (18); rewind (19); rewind (20)


do 11 i=1,L1/6  
	do j=1,2
                read(16,*) m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, (i-1)*6+j
                write(11,'(3f20.9)')x,y,z
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
        enddo

	do j=3,6
                read(17,*) m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, (i-1)*6+j
                write(11,'(3f20.9)')x,y,z
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
        enddo

11 enddo

Nfix=0  ! Initialization
coun=0

do 12 i=1,(L-L1)/16   
        do j=1,6
               read(18,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, L1+(i-1)*16+j
                write(11,'(3f20.9)')x,y,z
                 if (z.le.Zmin) then
                  coun=coun+1
                 endif
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
       enddo
        do j=7,8
                read(19,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, L1+(i-1)*16+j
                write(11,'(3f20.9)')x,y,z
                 if (z.le.Zmin) then
                  coun=coun+1
                 endif
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
       enddo
        do j=9,16
                read(20,'(a8,i10,9f20.9)')m,type,x,y,z,vx,vy,vz,fx,fy,fz
                write(11,'(a8,i10)') m, L1+(i-1)*16+j
                write(11,'(3f20.9)')x,y,z
                 if (z.le.Zmin) then
                  coun=coun+1
                 endif
                write(11,'(3f20.9)')vx,vy,vz
                write(11,'(3f20.9)')fx,fy,fz
       enddo

       if (coun.ge.(Nfix+1)) then
         Nfix=Nfix+1
         coun=Nfix
       endif
12 enddo

write(*,*) "the number of groups in Li3PO4 need to be fixed is", Nfix

close(unit=16,status='delete'); close(unit=17, status='delete')
close(unit=18, status='delete'); close(unit=19, status='delete')
close(unit=20, status='delete')
close(unit=10)
close(unit=11)
end program main

